function lstest(linesearch,fun,point,dir,maxa,c1,c2);

[fval,fgrad]=feval(fun,point,1);
dirderiv=fgrad'*dir;

if (length(point)==1)
  x=point-0.01*maxa*dir:maxa*dir/100:point+1.01*maxa*dir;
  y=zeros(2,length(x));
  for i=1:length(x)
    y(1,i)=feval(fun,x(i),1);
    y(2,i)=fval+c1*dirderiv*(x(i)-point)/norm(dir);
  end  
  figure(1);
  hold off;
  clf;
  axis([min(x), max(x), min(y(1,:))-0.1 max(y(1,:))+0.1]);
  axis manual;
  hold on;
  plot(x,y);
  plot(point,[fval],'ko');
elseif (length(point)==2)
  disp('2D: compute contour plot');
  dx=dir(1)*maxa/100;
  dy=dir(2)*maxa/100;
  x=point(1)-10*dx:dx:point(1)+120*dx;
  y=point(2)-10*dy:dy:point(2)+120*dy;
  z=zeros(length(x),length(y));
  for i=1:length(x)
    for j=1:length(y)
      z(i,j)=feval(fun,[x(i); y(j)],1);
    end
  end
  figure(1);               % output next plot on window of figure 1 
  hold off;                % overwrite old plot in figure 1
  clf;
  contour(x,y,z',[0.1,0.5,2.5,12.5,62.5,312.5]);     % plot the function
  xlabel('x');             % output 'x' along x axis
  ylabel('y');             % output 'y' along y axis
  hold on;
  plot([point(1)],[point(2)],'ok');
  plot([point(1)+maxa*dir(1)],[point(2)+maxa*dir(2)],'oc');
end

global fun_cnt;
fun_cnt=0;

disp(['Start line search']);
pause;


[lspoint,lsval,lsgrad]=feval(linesearch,fun,point,dir,maxa,fval,fgrad,c1,c2);

disp(['line search done,   number of evaluations = ' num2str(fun_cnt)]);

alpha=norm(lspoint-point)/norm(dir);
if (alpha>maxa)
  disp(['ERROR: step size too big:' num2str(alpha) '!<=' num2str(maxa)]);
end  
if (norm(lspoint-(point+alpha*dir))>1e-6)
  disp(['ERROR: output point not on the half ray!']);
end

[nval,ngrad]=feval(fun,lspoint,1);
if (norm(nval-lsval)>1e-6)
  disp(['ERROR: output objective value incorrect!']);
end
if (norm(ngrad-lsgrad)>1e-6)
  disp(['ERROR: output gradient incorrect!']);
end

if (length(lspoint)==1)
  plot(lspoint,lsval,'k*');
elseif (length(lspoint==2))
  plot(lspoint(1),lspoint(2),'k*');
end

if (nval>fval+c1*alpha*dirderiv)
  disp(['ERROR: Armijo is violated']);
end

if (alpha<0.999*maxa) & (lsgrad'*dir<c2*dirderiv)
  disp(['ERROR: Curvature is violated']);
end

pause;
